//+------------------------------------------------------------------+
//|                                        TrendFolowerLordDENv7.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Stelmak Denis, Skype LordDENps"
#property link      "http://www.tradelikeapro.ru"
//   .  .
//   0.1 0.2  
//---- input parameters
extern double    Risk=0.1; // lot=Risk*AccountBalance()/1000;  0.1     .
int PERIOD=PERIOD_H4; //   M1_M5_M15_M30_H1_H4_W1_MN1   H4
extern double    stop=50;
extern double    sl=50; //  -. (=    +*sl )
extern double    lot=0.1; //   .
extern int       tp=900; //  
extern int       slippag1=3; // 
extern int TrailingStop =475; //   .   14 .
extern int Magic = 12380; //
extern bool fikslot=false; //  -   ...   :)
extern bool fiksstop=false; //   .
extern bool trail=false; //
extern bool day10=false; //     10 
datetime prevtime;
extern string com =" Gambit_LordDEN, tradelikeapro.ru ";// .

void Trailing()//  
{
 for(int cnt=0;cnt<OrdersTotal();cnt++)
  if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
   {
    int orderType=OrderType();
    if(orderType<=OP_SELL && //      
       OrderSymbol()==Symbol()) // check for symbol
      {
       if(orderType==OP_BUY) //    
         {
          // check for trailing stop
          if(TrailingStop>0) 
           { 
            if(Bid-OrderOpenPrice()>Point*TrailingStop)
              {
               if(OrderStopLoss()<Bid-Point*TrailingStop)
                 {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                  Print("Order BUY Tral modify ",Bid-Point*TrailingStop);
                  return(0);
                 }
              }
           } 
         }
        else //    
         {
          // check for trailing stop
          if(TrailingStop>0) 
           { 
            if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
             {
              if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
               {
                OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                Print("Order SELL Tral modify ",Ask+Point*TrailingStop);
                return(0);
               }
             }
           }
         }
      }
   }
 return(0);      
}

int init()
{

}


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(trail)
   Trailing();
   
      Comment(
  "Gambit  LordDEN","\n",
  " = ",tp,"\n",
  "     Tradelikeapro.ru","\n",
  "  = ", Period( ),"  ","\n",
  "    = ", Period( )-(TimeCurrent()- iTime(Symbol(),PERIOD,0))/60, "  ","\n",
  "    = ", Period( )*60-(TimeCurrent()- iTime(Symbol(),PERIOD,0)), "  " 
   );  
   
   
    if(Time[0] == prevtime)   return(0);  //  
    prevtime = Time[0];  
   PERIOD = Period( ) ;                 //    , 
 
  if( fikslot == false )
  lot=NormalizeDouble(Risk*AccountBalance()/1000,1); // 
  double h0=iHigh(Symbol(),PERIOD,1*PERIOD); //   ,    
  double l0=iLow(Symbol(),PERIOD,1*PERIOD); // 
  double c0=iClose(Symbol(),PERIOD,1*PERIOD); //.
  double o0=iOpen(Symbol(),PERIOD,1*PERIOD); //.
  double h1=iHigh(Symbol(),PERIOD,2*PERIOD); //   ,    
  double l1=iLow(Symbol(),PERIOD,2*PERIOD); // 
  double 1=iClose(Symbol(),PERIOD,2*PERIOD); //.
  double o1=iOpen(Symbol(),PERIOD,2*PERIOD); //.
  double spread=MarketInfo(Symbol(),MODE_SPREAD); // 
  double bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,0);
  double bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,0);
  double bb0v2=iBands(NULL,0,30,2,0,PRICE_CLOSE,MODE_UPPER,0);
  double bb0n2=iBands(NULL,0,30,2,0,PRICE_CLOSE,MODE_LOWER,0);
  double bb0s=(bb0n+bb0v)/2;
  //   10 .
  double a1bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,1*PERIOD);
  double a1bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,1*PERIOD);
  double a1bb0s=(a1bb0n+a1bb0v)/2;
  
  double a2bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,2*PERIOD);
  double a2bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,2*PERIOD);
  double a2bb0s=(a2bb0n+a2bb0v)/2;
  
  double a3bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,3*PERIOD);
  double a3bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,3*PERIOD);
  double a3bb0s=(a3bb0n+a3bb0v)/2;
  
  double a4bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,4*PERIOD);
  double a4bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,4*PERIOD);
  double a4bb0s=(a4bb0n+a4bb0v)/2;
  
  double a5bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,5*PERIOD);
  double a5bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,5*PERIOD);
  double a5bb0s=(a5bb0n+a5bb0v)/2;
  
  double a6bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,6*PERIOD);
  double a6bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,6*PERIOD);
  double a6bb0s=(a6bb0n+a6bb0v)/2;
  
  double a7bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,7*PERIOD);
  double a7bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,7*PERIOD);
  double a7bb0s=(a7bb0n+a7bb0v)/2;
  
  double a8bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,8*PERIOD);
  double a8bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,8*PERIOD);
  double a8bb0s=(a8bb0n+a8bb0v)/2;
  
  double a9bb0v=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_UPPER,9*PERIOD);
  double a9bb0n=iBands(NULL,0,30,1,0,PRICE_CLOSE,MODE_LOWER,9*PERIOD);
  double a9bb0s=(a9bb0n+a9bb0v)/2;
  bool up=true;
  bool down=true;
  
 
  
  
  // 
  
  
  
    for(int jz=0; jz<OrdersTotal(); jz++)          
  if (OrderSelect(jz,SELECT_BY_POS, MODE_TRADES))
  {
    if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic &&  c0>bb0v2)
    OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), slippag1, Green);
    if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic &&  c0<bb0n2)
     OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask, Digits), slippag1, Red);
  } 
 
 
  for(int ji=0; ji<OrdersTotal(); ji++)          
  if (OrderSelect(ji,SELECT_BY_POS, MODE_TRADES))
  {
    if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
     return(0);
    if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
     return(0);
  }
  
  
  
  double stopsell=stop;
  double stopbuy=stop;
  if(fiksstop==false)
  {
  stopsell = h0+spread*Point*sl;
  stopbuy = l0-spread*Point*sl;
  }
  
  
  if(day10)
  {
  if (a9bb0s>a8bb0s && a7bb0s>a6bb0s && a5bb0s>a4bb0s && a3bb0s>a2bb0s)
  down = true;else down=false;
  if (a9bb0s<a8bb0s && a7bb0s<a6bb0s && a5bb0s<a4bb0s && a3bb0s<a2bb0s)
  up = true;else up=false; 
  }
  
  
  
  
  if (h0>h1 && l0>l1 && c0<(h0-l0)/2 && c0<bb0s && h0>bb0n && down==true) //
  OrderSend(Symbol(),OP_SELL,lot,Bid,slippag1,stopsell,l1-spread*Point-tp*Point,com,Magic);//sell
  
  if (l0<l1 && h0<h1 && c0>(h0-l0)/2 && c0>bb0s && c0<bb0v && up==true) //
  OrderSend(Symbol(),OP_BUY,lot,Ask,slippag1,stopbuy,h1+spread*Point+tp*Point,com,Magic);//buy
 

 
  
  
  
  
  
  
  
  
  
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+